﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

namespace Glass
{
    public partial class Client_add : Form
    {
        public Client_add()
        {
            InitializeComponent();
            cbFill();
            city.DropDownStyle = ComboBoxStyle.DropDownList;
            
        }

        private void back_Click(object sender, EventArgs e)
        {
            Hide();
            Clients sotrudniki = new Clients();
            sotrudniki.Show();
            sotrudniki.Location = Location;
            BD.diagWrite("Переход на форму Клиенты");
        }

        /// <summary>
        /// Проверка данных на корректность перед сохранением в БД
        /// </summary>
        /// <param name="check">Проверка пройдена (true) или нет (false)</param>
        public void checkData(ref bool check, string surname, string name, string patronymic, int city,  string phone)
        {
            try
            {
                if (!Regex.IsMatch(surname, @"^[А-Я][а-я]+$"))
                {
                    MessageBox.Show("Введите фамилию корректно!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(name, @"^[А-Я][а-я]+$"))
                {
                    MessageBox.Show("Введите имя корректно!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(patronymic, @"^[А-Я][а-я]+$"))
                {
                    MessageBox.Show("Введите отчество корректно!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (city == -1)
                {
                    MessageBox.Show("Выберите город из списка!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(phone, @"^\+7 \(9[0-9]{2}\) [0-9]{3}-[0-9]{2}-[0-9]{2}$"))
                {
                    MessageBox.Show("Введите корректный номер телефона!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else
                {
                    check = true;
                }
            }
            catch
            {
                MessageBox.Show("Возникла ошибка. Проверьте введённые данные!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }
        /// <summary>
        /// Добавление данных в БД
        /// </summary>
        private void fillTable()
        {

            SqlCommand command = new SqlCommand("INSERT INTO Klient VALUES(@name, @surname, @phone, @patronymic, @city, @org )", BD.connect());
            command.Parameters.AddWithValue("name", t_name.Text);
            command.Parameters.AddWithValue("surname", t_fam.Text);
            command.Parameters.AddWithValue("phone", maskedTextBox1.Text);
            command.Parameters.AddWithValue("patronymic", t_otch.Text);
            command.Parameters.AddWithValue("city",city.SelectedIndex + 1);
            
         
            command.Parameters.AddWithValue("org", org.Text);
            
            command.ExecuteNonQuery();
        }

        /// <summary>
        /// Заполнение значений ComboBox
        /// </summary>
        private void cbFill()
        {
            SqlDataReader sqlReader = null;
            SqlCommand command = new SqlCommand("SELECT * FROM City", BD.connect());
            sqlReader = command.ExecuteReader();
            while (sqlReader.Read())
            {
                city.Items.Add(sqlReader["city"]);
            }
            sqlReader.Close();
        }

        private void Client_add_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.Exit();
        }

        private void add_Click_1(object sender, EventArgs e)
        {
            bool check = false;
            checkData(ref check, t_fam.Text, t_name.Text, t_fam.Text, city.SelectedIndex,  maskedTextBox1.Text);
            if (check)
            {
                fillTable();
                MessageBox.Show("Клиент успешно добавлен!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Information);
                t_name.Text = "";
                t_fam.Text = "";
                t_otch.Text = "";

                maskedTextBox1.Text = "";
                city.Text = null;
                org.Text = "";


            }
        }

        private void add_MouseEnter(object sender, EventArgs e)
        {
            add.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void add_MouseLeave(object sender, EventArgs e)
        {
            add.ForeColor = SystemColors.Highlight;
        }

        private void add_MouseDown(object sender, MouseEventArgs e)
        {
            add.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void back_MouseEnter(object sender, EventArgs e)
        {
            back.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void back_MouseLeave(object sender, EventArgs e)
        {
            back.ForeColor = SystemColors.Highlight;
        }

        private void back_MouseDown(object sender, MouseEventArgs e)
        {
            back.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }
    }
}
