﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

namespace Glass
{
    public partial class Sotr_add : Form
    {
        public Sotr_add()
        {
            InitializeComponent();
            cbFill();
            dolg.DropDownStyle = ComboBoxStyle.DropDownList;

            
        }

        private void Sotr_add_Load(object sender, EventArgs e)
        {

        }

        private void back_Click(object sender, EventArgs e)
        {
            Hide();
            Sotrudniki sotrudniki = new Sotrudniki();
            sotrudniki.Show();
            sotrudniki.Location = Location;
            BD.diagWrite("Переход на форму Сотрудники");
        }

        /// <summary>
        /// Проверка данных на корректность перед сохранением в БД
        /// </summary>
        /// <param name="check">Проверка пройдена (true) или нет (false)</param>
        public void checkData(ref bool check, string surname, string name, string patronymic, int dolgnost,  string date, string phone, string login, string password)
        {
            int year = DateTime.Now.Year - 14;
            int month = DateTime.Now.Month;
            int day = DateTime.Now.Day;
            bool checkLogin = false;

            SqlDataReader sqlReader = null;
            SqlCommand command = new SqlCommand("SELECT login_user FROM Logines", BD.connect());
            sqlReader = command.ExecuteReader();
            while (sqlReader.Read())
            {
                string loginCheck = Convert.ToString(sqlReader["login_user"]).Remove(1, 3);
                if (login == loginCheck)
                {
                    checkLogin = true;
                    break;
                }
            }
            sqlReader.Close();

            try
            {
                if (!Regex.IsMatch(surname, @"^[А-Я][а-я]+$"))
                {
                    MessageBox.Show("Введите фамилию корректно!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(name, @"^[А-Я][а-я]+$"))
                {
                    MessageBox.Show("Введите имя корректно!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(patronymic, @"^[А-Я][а-я]+$"))
                {
                    MessageBox.Show("Введите отчество корректно!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (dolgnost == -1)
                {
                    MessageBox.Show("Выберите должность из списка!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (Convert.ToInt32(date.Substring(0, 4)) < year - 80 || Convert.ToInt32(date.Substring(0, 4)) > year
                    || Convert.ToInt32(date.Substring(5, 2)) > 12 || Convert.ToInt32(date.Substring(0, 4)) == year && Convert.ToInt32(date.Substring(5, 2)) > month
                    || Convert.ToInt32(date.Substring(0, 4)) == year && Convert.ToInt32(date.Substring(5, 2)) == month && Convert.ToInt32(date.Substring(8, 2)) > day)
                {
                    MessageBox.Show("Введите корректную дату рождения!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(phone, @"^\+7 \(9[0-9]{2}\) [0-9]{3}-[0-9]{2}-[0-9]{2}$"))
                {
                    MessageBox.Show("Введите корректный номер телефона!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (login == "")
                {
                    MessageBox.Show("Введите логин корректно!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (checkLogin)
                {
                    MessageBox.Show("Логин занят!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (!Regex.IsMatch(password, @"(?!^[0-9]*$)(?!^[a-zA-Z]*$)^([a-zA-Z0-9]{4,})$"))
                {
                    MessageBox.Show("Введите пароль корректно!\nМинимум 4 символов\nСодержит как минимум 1 цифру и один символ латинского алфавита", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else
                {
                    check = true;
                }
            }
            catch
            {
                MessageBox.Show("Возникла ошибка. Проверьте введённые данные!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

        /// <summary>
        /// Добавление данных в БД
        /// </summary>
        private void fillTable()
        {
            string login;
            string password;
            login = t_login.Text;
            password = t_pass.Text;
            Random rnd = new Random();
            string shifr = Convert.ToString((char)rnd.Next(65, 91)) + Convert.ToString((char)rnd.Next(65, 91));
            login = login.Insert(1, shifr);
            shifr = Convert.ToString((char)rnd.Next(65, 91)) + Convert.ToString((char)rnd.Next(65, 91));
            password = password.Insert(password.Length - 1, shifr);

            SqlCommand command = new SqlCommand("INSERT INTO Logines VALUES(@login, @password)", BD.connect());
            command.Parameters.AddWithValue("login", login);
            command.Parameters.AddWithValue("password", password);
            command.ExecuteNonQuery();

            int id_user = 0;
            SqlDataReader sqlReader = null;
            command = new SqlCommand("SELECT kod_user FROM Logines WHERE login_user = @login", BD.connect());
            command.Parameters.AddWithValue("login", login);
            sqlReader = command.ExecuteReader();
            while (sqlReader.Read())
            {
                id_user = Convert.ToInt32(sqlReader["kod_user"]);
                break;
            }
            sqlReader.Close();

            command = new SqlCommand("INSERT INTO Sotrydnik VALUES(@fam, @name, @otc, @date, @tel, @dolg,  @user)", BD.connect());
            command.Parameters.AddWithValue("fam", t_fam.Text);
            command.Parameters.AddWithValue("name",t_name.Text);
            command.Parameters.AddWithValue("otc", t_fam.Text);
            string date = dateTimePicker.Value.ToString("yyyy-MM-dd");
            command.Parameters.AddWithValue("date", date);
            command.Parameters.AddWithValue("tel", maskedTextBox1.Text);
            command.Parameters.AddWithValue("dolg", dolg.SelectedIndex + 1);
            command.Parameters.AddWithValue("user", id_user);
            command.ExecuteNonQuery();
        }

        /// <summary>
        /// Заполнение значений ComboBox
        /// </summary>
        private void cbFill()
        {
            SqlDataReader sqlReader = null;
            SqlCommand command = new SqlCommand("SELECT * FROM Dolgnosti", BD.connect());
            sqlReader = command.ExecuteReader();
            while (sqlReader.Read())
            {
                dolg.Items.Add(sqlReader["name_dolgnosti"]);
            }
            sqlReader.Close();
        }

        private void add_Click(object sender, EventArgs e)
        {
            bool check = false;
            checkData(ref check, t_fam.Text, t_name.Text, t_otch.Text, dolg.SelectedIndex,  dateTimePicker.Value.ToString("yyyy-MM-dd"), maskedTextBox1.Text, t_login.Text,t_pass.Text);
            if (check)
            {
                fillTable();
                MessageBox.Show("Сотрудник успешно добавлен!", "Добавление сотрудника", MessageBoxButtons.OK, MessageBoxIcon.Information);
                t_name.Text = "";
                t_fam.Text = "";
                t_otch.Text = "";
                dateTimePicker.Text = "";
                maskedTextBox1.Text = "";
                dolg.Text = null;
                t_login.Text = "";
                t_pass.Text = "";

            }
        }
        private void Sotr_add_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.Exit();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            if (t_pass.UseSystemPasswordChar == false)
            {
                t_pass.UseSystemPasswordChar = true;
                pictureBox1.BackgroundImage = Properties.Resources.baseline_visibility_black_24dp;
            }
            else
            {
                t_pass.UseSystemPasswordChar = false;
                pictureBox1.BackgroundImage = Properties.Resources.baseline_visibility_off_black_24dp;
            }
        }
        private void add_MouseEnter(object sender, EventArgs e)
        {
            add.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void add_MouseLeave(object sender, EventArgs e)
        {
            add.ForeColor = SystemColors.Highlight;
        }

        private void add_MouseDown(object sender, MouseEventArgs e)
        {
            add.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void back_MouseEnter(object sender, EventArgs e)
        {
            back.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void back_MouseLeave(object sender, EventArgs e)
        {
            back.ForeColor = SystemColors.Highlight;
        }

        private void back_MouseDown(object sender, MouseEventArgs e)
        {
            back.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }
    }
}
