﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

namespace Glass
{
    public partial class Tovar_add : Form
    {
        public Tovar_add()
        {
            InitializeComponent();
            cbFill();
            marka.DropDownStyle = ComboBoxStyle.DropDownList;
            tip.DropDownStyle = ComboBoxStyle.DropDownList;
        }

        private void Tovar_add_Load(object sender, EventArgs e)
        {

        }

 

        private void back_Click(object sender, EventArgs e)
        {
            Hide();
            Tovar sotrudniki = new Tovar();
            sotrudniki.Show();
            sotrudniki.Location = Location;
            BD.diagWrite("Переход на форму Клиенты");
        }

        /// <summary>
        /// Проверка данных на корректность перед сохранением в БД
        /// </summary>
        /// <param name="check">Проверка пройдена (true) или нет (false)</param>
        public void checkData(ref bool check)
        {
            try
            {
                if (marka.SelectedIndex == -1)
                {
                    MessageBox.Show("Выберите марку машины!", "Добавление товара", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (tip.SelectedIndex == -1)
                {
                    MessageBox.Show("Выберите тип стекла!", "Добавление товара", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (price.Text == "" || Convert.ToInt32( price.Text) <= 0)
                {
                    MessageBox.Show("Введите цену корректно!", "Добавление товара", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (kolic.Text == "" || Convert.ToInt32(kolic.Text) <= 0)
                {
                    MessageBox.Show("Введите количество корректно!", "Добавление товара", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (artic.Text == "")
                {
                    MessageBox.Show("Введите артукул!", "Добавление товара", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else
                {
                    check = true;
                }
            }
            catch
            {
                MessageBox.Show("Возникла ошибка. Проверьте введённые данные!", "Добавление клиента", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }
        /// <summary>
        /// Добавление данных в БД
        /// </summary>
        private void fillTable()
        {

            SqlCommand command = new SqlCommand("INSERT INTO Products VALUES(@marka, @tip, @count, @kol, @artikl)", BD.connect());
            command.Parameters.AddWithValue("marka", marka.SelectedIndex + 1);
            command.Parameters.AddWithValue("tip", tip.SelectedIndex + 1);
            command.Parameters.AddWithValue("count", Convert.ToInt32(price.Text));
            command.Parameters.AddWithValue("kol", Convert.ToInt32(kolic.Text));
            command.Parameters.AddWithValue("artikl", artic.Text);

            command.ExecuteNonQuery();
        }

        /// <summary>
        /// Заполнение значений ComboBox
        /// </summary>
        private void cbFill()
        {
            SqlDataReader sqlReader = null;
            SqlCommand command = new SqlCommand("SELECT * FROM Tipst", BD.connect());
            sqlReader = command.ExecuteReader();
            while (sqlReader.Read())
            {
               tip.Items.Add(sqlReader["Names"]);
            }
            sqlReader.Close();

            SqlDataReader sqlReaderr = null;
            SqlCommand commandd = new SqlCommand("SELECT * FROM Marki", BD.connect());
            sqlReaderr = commandd.ExecuteReader();
            while (sqlReaderr.Read())
            {
               marka.Items.Add(sqlReaderr["marka"]);
            }
            sqlReaderr.Close();
        }

        private void add_Click(object sender, EventArgs e)
        {

            bool check = false;
            checkData(ref check);
            if (check)
            {
                fillTable();
                MessageBox.Show("Товар добавлен!", "Добавление товара", MessageBoxButtons.OK, MessageBoxIcon.Information);
                marka.Text = null;
                tip.Text = null;
                price.Text = "";
                kolic.Text = "";
                artic.Text = "";

            }

        }

        private void add_MouseEnter(object sender, EventArgs e)
        {
            add.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void add_MouseLeave(object sender, EventArgs e)
        {
            add.ForeColor = SystemColors.Highlight;
        }

        private void add_MouseDown(object sender, MouseEventArgs e)
        {
            add.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void back_MouseEnter(object sender, EventArgs e)
        {
            back.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }

        private void back_MouseLeave(object sender, EventArgs e)
        {
            back.ForeColor = SystemColors.Highlight;
        }

        private void back_MouseDown(object sender, MouseEventArgs e)
        {
            back.ForeColor = Color.FromArgb(100, 237, 237, 237);
        }
    }
}
